// NinePointCircle.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <conio.h>
#include <math.h>

using namespace std;

float determinate(float a, float b, float c, float d)
{
	float r;
	r = a*d - b*c;
	return (r);
}

float equsolver(float a, float b, float c, float k, float g, float w, int xory)
/* 
a: slope1
b: 1
c: b1
k: slope2
g: 1
w: b2

Even though the python implementation takes four arguments, it is assumed that the coefficient of y is of value 1. 
Here in the form -mx+y=b y is a given value of one and its solved like a Ax+By=C standard form equation
*/
{
	float coefficientMatrix[2][2] =
	{
		{ a, b },
		{ k, g }
	};
	float determinantOfCoefficientMatrix = determinate(coefficientMatrix[0][0], coefficientMatrix[1][0], coefficientMatrix[0][1], coefficientMatrix[1][1]);
	float DxMatrix[2][2] =
	{
		{ c, b },
		{ w, g }
	};
	float determinantOfDxMatrix = determinate(DxMatrix[0][0], DxMatrix[1][0], DxMatrix[0][1], DxMatrix[1][1]);
	float DyMatrix[2][2] =
	{
		{ a, c },
		{ k, w }
	};
	float determinantOfDyMatrix = determinate(DyMatrix[0][0], DyMatrix[1][0], DyMatrix[0][1], DyMatrix[1][1]);
	float Yanswer = (determinantOfDyMatrix / determinantOfCoefficientMatrix);
	float Xanswer = (determinantOfDxMatrix / determinantOfCoefficientMatrix);
	if (xory == 0)
		return Xanswer;
	else
		return Yanswer;
}

float slopemaster(float h1, float k1, float h2, float k2)
{
	return(((k2 - k1) / (h2 - h1)));
}

float bcalc(float g, float slope, float j)
{
	return(j - (slope*g));
}

float OppInvSlopeCalc(float m)
{
	return pow((m*-1), (-1));
}

float DistanceCalc(float x1,float y1,float x2,float y2)
{
	return sqrt((x2 - x1)*(x2 - x1) + (y2 - y1)*(y2 - y1));
}

float calculator(float X1, float Y1, float X2, float Y2, float X3, float Y3)
{
	float Lx = (X1 + X2) / 2;
	float Ly = (Y1 + Y2) / 2;
	float Mx = (X2 + X3) / 2;
	float My = (Y2 + Y3) / 2;
	float Nx = (X1 + X3) / 2;
	float Ny = (Y1 + Y3) / 2;
	//calculates the midpoints of the lines created by the points
	float slopeAB = slopemaster(X1, Y1, X2, Y2);
	float slopeBC = slopemaster(X2, Y2, X3, Y3);
	float slopeAC = slopemaster(X1, Y1, X3, Y3);
	//calculates the slope of the lines created by the points
	float ABb = bcalc(X1, slopeAB, Y1);
	float BCb = bcalc(X2, slopeBC, Y2);
	float ACb = bcalc(X3, slopeAC, Y3);
	//calculates the b values for the equations of the lines created by the points
	float OppInvSlopeAB = OppInvSlopeCalc(slopeAB);
	float OppInvSlopeBC = OppInvSlopeCalc(slopeBC);
	float OppInvSlopeAC = OppInvSlopeCalc(slopeAC);
	//calculates the opposite inverse slope of the lines created by the points
	float slopeCD = OppInvSlopeAB;
	float slopeAE = OppInvSlopeBC;
	float slopeBF = OppInvSlopeAC;
	//renames the opposite inverse slope as the slope of the perpendicular line
	float AltbAB = bcalc(X3, OppInvSlopeAB, Y3);
	float AltbBC = bcalc(X1, OppInvSlopeBC, Y1);
	float AltbAC = bcalc(X2, OppInvSlopeAC, Y2);
	//calculates the b value of the altitude of the equation of the line listed
	float Ex = equsolver(slopeBC, 1, BCb, slopeAE, 1, AltbBC, 0);
	float Ey = equsolver(slopeBC, 1, BCb, slopeAE, 1, AltbBC, 1);
	float Fx = equsolver(slopeAC, 1, ACb, slopeBF, 1, AltbAC, 0);
	float Fy = equsolver(slopeAC, 1, ACb, slopeBF, 1, AltbAC, 1);
	float Dx = equsolver(slopeAB, 1, ABb, slopeCD, 1, AltbAB, 0);
	float Dy = equsolver(slopeAB, 1, ABb, slopeCD, 1, AltbAB, 1);
	//unpacks the values from the array and turns them into floats with variable names
	float OrthoX = equsolver(slopeCD, 1, AltbAB, slopeAE, 1, AltbBC, 0);
	float OrthoY = equsolver(slopeCD, 1, AltbAB, slopeAE, 1, AltbBC, 1);
	//finds the x and y coordinates of the orthocenter
	float AHmdptX = ((OrthoX + X1) / 2);
	float AHmdptY = ((OrthoY + Y1) / 2);
	float BHmdptX = ((OrthoX + X2) / 2);
	float BHmdptY = ((OrthoY + Y2) / 2);
	float CHmdptX = ((OrthoX + X3) / 2);
	float CHmdptY = ((OrthoY + Y3) / 2);
	//finds the midpoints of the segments of the vertices and the orthocenter
	float XcoordinateMDPTx = ((Mx + Nx) / 2);
	float YcoordinateMDPTx = ((My + Ny) / 2);
	float XcoordinateMDPTy = ((Nx + Lx) / 2);
	float YcoordinateMDPTy = ((Ny + Ly) / 2);
	float XcoordinateMDPTz = ((Mx + Lx) / 2);
	float YcoordinateMDPTz = ((My + Ly) / 2);
	//calculates the coordinates of the midpoints of the lines drawn from the outer midpoints
	float slopeMN = slopemaster(Mx, My, Nx, Ny);
	float slopeNL = slopemaster(Nx, Ny, Lx, Ly);
	float slopeLM = slopemaster(Lx, Ly, Mx, My);
	//calculates the slope of the the midpoints of the triangle
	float MNoppslope = OppInvSlopeCalc(slopeMN);
	float NLoppslope = OppInvSlopeCalc(slopeNL);
	float LMoppslope = OppInvSlopeCalc(slopeLM);
	//calculates the opposite inverse of the slope of the midpoints of the triangle
	float PerpbMN = bcalc(XcoordinateMDPTx, MNoppslope, YcoordinateMDPTx);
	float PerpbNL = bcalc(XcoordinateMDPTy, NLoppslope, YcoordinateMDPTy);
	float PerpbLM = bcalc(XcoordinateMDPTz, LMoppslope, YcoordinateMDPTz);
	//calculates the b value of the equation of the perpendicular bisector
	float centerX = (-1)*equsolver(MNoppslope, 1, PerpbMN, NLoppslope, 1, PerpbNL, 0);
	float centerY = equsolver(MNoppslope, 1, PerpbMN, NLoppslope, 1, PerpbNL, 1);
	cout << "Center Point:\n";
	cout << "X:\n";
	cout << centerX << "\n";
	cout << "Y:\n";
	cout << centerY << "\n";
	return (centerX);
}

void pause()
{
	cout << "Press any key to continue....";
	while (1)
	{
		if (_kbhit())
		{
			break;
		}
	}
}

int _tmain(int argc, _TCHAR* argv[])
{

	signed int x1input, y1input, x2input, y2input, x3input, y3input;
	
	
	cout << "X1:";
	cin >> x1input;
	
	cout << "Y1:";
	cin >> y1input;

	cout << "X2:";
	cin >> x2input;

	cout << "Y2:";
	cin >> y2input;

	cout << "X3:";
	cin >> x3input;

	cout << "Y3:";
	cin >> y3input;
	
	float points = calculator(x1input, y1input, x2input, y2input, x3input, y3input);
	pause();
	return 0;
}