void calculator(float X1, float Y1,float X2,float Y2,float X3,float Y3)
{
float Lx = (X1+X2)/2;
float Ly = (Y1+Y2)/2;
float Mx = (X2+X3)/2;
float My = (Y2+Y3)/2;
float Nx = (X1+X3)/2;
float Ny = (Y1+Y3)/2;
//calculates the midpoints of the lines created by the points
float slopeAB = slopemaster(X1, Y1, X2, Y2);
float slopeBC = slopemaster(X2, Y2, X3, Y3);
float slopeAC = slopemaster(X1, Y1, X3, Y3);
//calculates the slope of the lines created by the points
float ABb = bcalc(X1, slopeAB, Y1);
float BCb = bcalc(X2, slopeBC, Y2);
float ACb = bcalc(X3, slopeAC, Y3);
//calculates the b values for the equations of the lines created by the points
float OppInvSlopeAB = OppInvSlopeCalc(slopeAB);
float OppInvSlopeBC = OppInvSlopeCalc(slopeBC);
float OppInvSlopeAC = OppInvSlopeCalc(slopeAC);
//calculates the opposite inverse slope of the lines created by the points
float slopeCD = OppInvSlopeAB;
float slopeAE = OppInvSlopeBC;
float slopeBF = OppInvSlopeAC;
//renames the opposite inverse slope as the slope of the perpendicular line
float AltbAB = bcalc(X3, OppInvSlopeAB, Y3);
float AltbBC = bcalc(X1, OppInvSlopeBC, Y1);
float AltbAC = bcalc(X2, OppInvSlopeAC, Y2);
//calculates the b value of the altitude of the equation of the line listed
float Ecoordinates = equsolver(slopeBC, BCb, slopeAE, AltbBC);
float Fcoordinates = equsolver(slopeAC, ACb, slopeBF, AltbAC);
float Dcoordinates = equsolver(slopeAB, ABb, slopeCD, AltbAB);
//calculates the values of x and y that are true for both equations

/*
float Ex = Ecoordinates[0];
float Ey = Ecoordinates[1];
float Fx = Fcoordinates[0];
float Fy = Fcoordinates[1];
float Dx = Dcoordinates[0];
float Dy = Dcoordinates[1];
*/


float Ex = equsolver(slopeBC, 1, BCb, slopeAE, 1, AltbBC, 0);
float Ey = equsolver(slopeBC, 1, BCb, slopeAE, 1, AltbBC, 1);
float Fx = equsovler(slopeAC, 1, ACb, slopeBF, 1, AltbAC, 0);
float Fy = equsolver(slopeAC, 1, ACb, slopeBF, 1, AltbAC, 1);
float Dx = equsolver(slopeAB, 1, ABb, slopeCD, 1, AltbAB, 0);
float Dy = equsolver(slopeAB, 1, ABb, slopeCD, 1, AltbAB, 1);





//unpacks the values from the array and turns them into floats with variable names

/*float Orthopoints = equsolver(slopeCD, AltbAB, slopeAE, AltbBC);
float OrthoX = Orthopoints[0];
float OrthoY = Orthopoints[1];
*/

float OrthoX = equsovler(slopeCD, 1, AltbAB, slopeAE, 1, AltbBC, 0);
float OrthoY = equsovler(slopeCD, 1, AltbAB, slopeAE, 1, AltbBC, 1);
//finds the x and y coordinates of the orthocenter
float AHmdptX = ((OrthoX + X1)/2);
float AHmdptY = ((OrthoY + Y1)/2);
float BHmdptX = ((OrthoX + X2)/2);
float BHmdptY = ((OrthoY + Y2)/2);
float CHmdptX = ((OrthoX + X3)/2);
float CHmdptY = ((OrthoY + Y3)/2);
//finds the midpoints of the segments of the vertices and the orthocenter
float XcoordinateMDPTx = ((Mx + Nx)/2);
float YcoordinateMDPTx = ((My + Ny)/2);
float XcoordinateMDPTy = ((Nx + Lx)/2);
float YcoordinateMDPTy = ((Ny + Ly)/2);
float XcoordinateMDPTz = ((Mx + Lx)/2);
float YcoordinateMDPTz = ((My + Ly)/2);
//calculates the coordinates of the midpoints of the lines drawn from the outer midpoints
float slopeMN = slopemaster(Mx, My, Nx, Ny);
float slopeNL = slopemaster(Nx, Ny, Lx, Ly);
float slopeLM = slopemaster(Lx, Ly, Mx, My);
//calculates the slope of the the midpoints of the triangle
float MNoppslope = OppInvSlopeCalc(slopeMN);
float NLoppslope = OppInvSlopeCalc(slopeNL);
float LMoppslope = OppInvSlopeCalc(slopeLM);
//calculates the opposite inverse of the slope of the midpoints of the triangle
float PerpbMN = bcalc(XcoordinateMDPTx, MNoppslope, YcoordinateMDPTx);
float PerpbNL = bcalc(XcoordinateMDPTy, NLoppslope, YcoordinateMDPTy);
float PerpbLM = bcalc(XcoordinateMDPTz, LMoppslope, YcoordinateMDPTz);
//calculates the b value of the equation of the perpendicular bisector


/*
float centercoordinates = equsolver(MNoppslope, PerpbMN, NLoppslope, PerpbNL);
float centerX = centercoordinates[0];
float centerY = centercoordinates[1];
float radius = distancecalc(centerX, centerY, Lx, Ly);
*/

float centerX = equsolver(MNoppslope, 1, PerpbMN, NLoppslope, 1, PerpbNL, 0);
float centerY = equsolver(MNoppslope, 1, PerpbMN, NLoppslope, 1, PerpbNL, 1);





















}